<template>
    <div>
        <h1>
            Clients
            <a href="/clients/create" class="float-right btn btn-primary"
                >+ New Client</a
            >
        </h1>

        <table class="table">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Phone</th>
                    <th>Number of Bookings</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="client in localClients" :key="client.id">
                    <td>{{ client.name }}</td>
                    <td>{{ client.email }}</td>
                    <td>{{ client.phone }}</td>
                    <td>{{ client.bookings_count }}</td>
                    <td>
                        <a
                            class="btn btn-primary btn-sm"
                            :href="`/clients/${client.id}`"
                            >View</a
                        >
                        <button
                            class="btn btn-danger btn-sm"
                            @click="deleteClient(client)"
                        >
                            Delete
                        </button>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>
import axios from 'axios';
import { defineComponent } from 'vue';

export default defineComponent({
    name: 'ClientsList',

    props: {
        clients: {},
    },

    data() {
        return {
            localClients: [],
        };
    },

    mounted() {
        this.localClients = this.clients;
    },

    methods: {
        deleteClient(client) {
            axios.delete(`/clients/${client.id}`).then(() => {
                const clientId = this.localClients.findIndex(
                    (item) => item.id === client.id
                );
                this.localClients.splice(clientId, 1);
            });
        },
    },
});
</script>
